/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "FoxAutoConfigurator.hpp"
#include "../AutoConfigurator.hpp"
#include "FoxIconManager.hpp"
#include "../Settings.hpp"

#include "config.h"
#include "gettext.h"
#define _(STRING)    gettext(STRING)

#include <vector>
#include <map>
using namespace std;



FoxAutoConfigurator::FoxAutoConfigurator(FXApp *_app)
: app(_app)
{
}


FoxAutoConfigurator::~FoxAutoConfigurator()
{
}

void FoxAutoConfigurator::setMimeAssociations( )
{

	FoxIconManager &foxIconManager=FoxSingleton<FoxIconManager>::instance(app);
		

	/*TODO*/
	FXWizard wizard(app,_("file type wizard"),foxIconManager.get("logo"),DECOR_TITLE|DECOR_BORDER,0,0,0,250);
	
		FXButton * but=wizard.advanceButton();
		but->setText(_("Next"));
		but=wizard.retreatButton();
		but->setText(_("Back"));
		but=wizard.finishButton();
		but->setText(_("Finish"));
		but=wizard.cancelButton();
		but->setText(_("Cancel"));
	
	
		AutoConfigurator &autoConfigurator=singleton<AutoConfigurator>::instance();

		map<string,vector<Program> > mimeProgramsMap;
		map<string,vector<Program> >::iterator iter;
		autoConfigurator.assignProgramsToMime(mimeProgramsMap);
		
		vector<FXIconList*> listBoxes;
		vector<FXIconList*>::iterator listIter;
		
		vector<string> mimeNames;
		map<string,Program> mimePrograms;
		map<string,Program> programsMap;
		
		for(iter=mimeProgramsMap.begin() ; iter!=mimeProgramsMap.end() ; ++iter )
		{	
				
			if(iter->second.size()==0)
			continue;	
				
			if(iter->second.size()==1)
			{
			mimePrograms[iter->first]=iter->second[0];
			programsMap[iter->second[0].getName()]=iter->second[0];
			continue;
			}
			
			mimeNames.push_back(iter->first);
				
			FXVerticalFrame *panel=new FXVerticalFrame(wizard.getContainer(),LAYOUT_FILL_Y|LAYOUT_FILL_X);
			string iconName=singleton<Settings>::instance().getMime(iter->first).getIcon();
			if(iconName=="")
			iconName="unknown";
			new FXLabel(panel,iter->first.c_str(),foxIconManager.get(iconName));
			FXIconList *listBox=new FXIconList (panel,NULL,0,ICONLIST_MINI_ICONS |LAYOUT_FILL_Y|LAYOUT_FILL_X );
			listBox->appendHeader(_("name"));
			listBoxes.push_back(listBox);
				
			vector<Program>::iterator iter2;
			for(iter2=iter->second.begin();iter2!=iter->second.end();++iter2)
			{
				programsMap[iter2->getName()]=*iter2;	
				listBox->appendItem(iter2->getName().c_str ()  ,NULL,foxIconManager.get("execute3"));
			}
		
			listBox->appendItem(_("NONE")  ,NULL,foxIconManager.get("execute3"));
			
			listBox->selectItem(0);
			int size=iter->second.size();
										
//			size<10 ? listBox->setNumVisible(size): listBox->setNumVisible( 10 );				
		}

		wizard.execute(PLACEMENT_SCREEN);
		
		
		int pos=0;
		for(listIter=listBoxes.begin();listIter!=listBoxes.end();++listIter)
		{
			string defaultProgramName=(*listIter)->getItem ( (*listIter)->getCurrentItem () )->getText().text ();
			string mimeName=mimeNames[pos];
			if(defaultProgramName!=_("NONE"))
			{
			mimePrograms[mimeName]=programsMap[defaultProgramName];	
			}				
			
			++pos;				
		}
		
		autoConfigurator.setDefaultPrograms(mimePrograms,mimeProgramsMap);		

}


