/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef FOXICONMANAGER_HPP
#define FOXICONMANAGER_HPP

#include <fx.h>
#include <string>
#include <map>
#include <vector>
#include <boost/filesystem/path.hpp>
#include "FoxSingleton.hpp"

using namespace std;

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class FoxIconManager
{
public:

    FXIcon* get(string name);
    vector<string> getAllIconsName(void);

    
private:
    
    ~FoxIconManager();
    FoxIconManager( FXApp *app );   
    std::map<std::string, FXIcon*> icons;    
    vector<string> allIconsName;
    FXIconSource *source;
          
          friend class FoxSingleton<FoxIconManager>;
    

};

#endif
