/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef FOXINPUTDIALOG_HPP
#define FOXINPUTDIALOG_HPP


#include "FoxGuiThreadSynchronization.hpp"
#include "WindowContent.hpp"


#include <fx.h>
#include <string>
#include <map>
using namespace std;


class FoxWidget
{
public:
	FoxWidget(string _name,string _type,FXWindow *_w):name(_name),type(_type),wind(_w){}
	FoxWidget(){}

	FXWindow* getFoxWidget() const
	{
	    return wind;
	}

	string getType() const
	{
	    return type;
	}

	string getName() const
	{
		return name;
	}
	
private:	
	
	string name;
	string type;
	FXWindow *wind;
};



/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class FoxInputDialog : public FXDialogBox
{
FXDECLARE(FoxInputDialog);

public:
    

   	~FoxInputDialog();
    
    	enum
    	{
	ID_CLICKED_BUTTON=FXDialogBox::ID_LAST,
	ID_PRESSED_ENTER,
	ID_LAST,
	};


	FoxInputDialog(FXWindow * owner,Wait *w,WindowContent *windowContent);	
	long onCmdClicked(FXObject*,FXSelector,void*);
	long onPressedEnter(FXObject*,FXSelector,void*);

private:
	FoxInputDialog(){}
	FXTextField* textField;
	Wait *w;
	map<string,FXWindow*>widgetsMap;
	vector<FoxWidget> widgetsVec;
	string defaultButton;
	

};

#endif
