/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FoxPanel_HPP
#define FoxPanel_HPP

#include "config.h"

#include <fx.h>

#ifdef  HAVE_LIBFOX_1_4
#include <FXGUISignal.h>
#endif


#include "../Panel.hpp"
#include "FoxPanel.hpp"
#include "FoxPanelManager.hpp"

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/




class FoxPanel : public Panel
{
public:
	FoxPanel(FoxPanelManager *foxPanelManager,string param="");
	FoxPanel(){}
	virtual ~FoxPanel();
	virtual void moveToRight(void);
	virtual void moveToLeft(void);
	virtual void moveToTop(void);
	virtual void close(void);   
	void setPath(string);
	virtual void setOpposite(FoxPanel* theValue);
	virtual void setPanelWidth(int);
	virtual void directoryLoaded();
	virtual void enable();
	virtual void disable();
	virtual bool canClose();
	virtual void createPanel(string name, string param );
	virtual void create ();
	virtual string getParam();
	virtual void setLabel(string text, string iconName="");
	virtual void setFocus(void);

	
	void setType(const string& theValue)
	{
	    type = theValue;
	}
	

	string getType() const
	{
	    return type;
	}
	

    	
FXVerticalFrame *frame;    	
    	
protected:

FXHorizontalFrame *hf;
FoxPanelManager *foxPanelManager; 
FXButton *label;    	
    	
private:

    void controlHide(void);
    void controlShow(void);
    void recalc(void);

FXButton *toleft,*toright,*toclose;    	
FoxPanel *opposite;
string type;
string param;
FXGUISignal *guiSignal;
   	



};

#endif
