/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "FoxStatus.hpp"
#include "FilesEngine.hpp"
#include "FoxIconManager.hpp"

#include "config.h"
#include "gettext.h"
#define _(STRING)    gettext(STRING)

#include <iostream>
using namespace std;

#include <boost/lexical_cast.hpp>
using boost::lexical_cast;


FXDEFMAP (FoxStatus) FoxStatusMap[] =
{
    FXMAPFUNC (SEL_COMMAND, FoxStatus::ID_CANCEL, FoxStatus::onCancel),  
};

FXIMPLEMENT (FoxStatus, FXDialogBox, FoxStatusMap, ARRAYNUMBER (FoxStatusMap));


FoxStatus::FoxStatus(FXWindow * owner,Cancelable *_cancelable)
 : FXDialogBox ( owner, _("status"), DECOR_ALL, 0, 0, 500, 0, 0, 0, 0, 0, 4, 4 ),
   app(owner->getApp())
{
	FXVerticalFrame *frame = new FXVerticalFrame( this, LAYOUT_FILL_X | FRAME_THICK, 0, 0, 0, 0, 0, 0 );
	progressTotal = new FXProgressBar( frame, NULL, 0, LAYOUT_FILL_X | FRAME_THICK | PROGRESSBAR_PERCENTAGE );
	progressCurrent = new FXProgressBar( frame, NULL, 0, LAYOUT_FILL_X | FRAME_THICK | PROGRESSBAR_PERCENTAGE );
	label1=new FXLabel(frame," ");
	label2=new FXLabel(frame," ");
	new FXButton (frame,_("cancel"), FoxSingleton<FoxIconManager>::instance(getApp()).get("cancel"), this, ID_CANCEL,BUTTON_TOOLBAR| ICON_BEFORE_TEXT);
	cancelable=_cancelable;
}


FoxStatus::~FoxStatus()
{

}


void FoxStatus::tick()
{
	string labelText1=_("elapsed: ")+ lexical_cast<string>(getTimeElapsed())+string("s ")+ _("speed: ")+ FilesEngine::printSize(getSpeed())+string("/s ")+_("estimated:")+lexical_cast<string>(getTimeEstimated())+"s";
	//string labelText2=
	progressTotal->setProgress (getTotalProgress());
	progressCurrent->setProgress (getCurrentProgress());
	
	label1->setText(currentFileName.c_str());
	label2->setText(labelText1.c_str());
}

long FoxStatus::onCancel(FXObject * obj, FXSelector sel, void * ptr)
{
	cancelable->setCanceledExecution();
}


