/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef VFSFLATDIRECTORY_HPP
#define VFSFLATDIRECTORY_HPP

#include "VfsLocal.hpp"

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class VfsFlatDirectory : public VfsLocal
{
public:
	VfsFlatDirectory();
	~VfsFlatDirectory();
	
	Directory openDir( path& p, Cancelable *cancelable=NULL  );
	void init(Panel *panel,QuestionManager *questionManager);
	
	void createDir(path p){}
    	void copyToFile(File &source, path &destination, Status * status,Cancelable *cancelable){}
    	
    	void setRelativePath(vector<string>&fields, File& file);
    	File readFullFile(File file);
    
protected:
    
    	File readDir( Directory *directory );
    
private:
    
    	map<string,string> params;
    	vector<File>files;
    	vector<File>::iterator iter;
    	
    	string rootDir;
    	
    	vector<void (VfsFlatDirectory::*)( vector<string>&, File& )> fileInfoVector;
	vector<void (VfsFlatDirectory::*)( vector<string>&, File& )>::iterator fileInfoVectorIter;
    	
	
};

#endif
