/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "VfsHistory.hpp"
#include "FilesEngine.hpp"
#include "Iconv.hpp"


#include "config.h"
#include "gettext.h"
#define _(STRING)    gettext(STRING)



REGISTER_FACTORABLE(VfsHistory);

VfsHistory::VfsHistory() 
{
}


VfsHistory::~VfsHistory()
{
}

Directory VfsHistory::openDir(path & p, Cancelable *cancelable)
{

	filesHistory=settings.getFilesHistory();
	iter=filesHistory.begin(); 
	Directory directory(this,NULL,p);
	return directory;
}

File VfsHistory::readDir(Directory * directory)
{
	while(iter!=filesHistory.end())
	{
		File file;
		try
		{
		file=readFile(path(*iter));
		}
		catch(ExceptionReadFile &e)
		{
			try
			{
			file=readFile(path(Iconv::fromUTF8(*iter)));
			}
			catch(ExceptionReadFile &e)
			{
				++iter;
				continue;
			}
			
		}
		
		
		
		++iter;
		return file;
	}
	
	throw ExceptionReadDirEnd();
}

void VfsHistory::init(Panel * _panel, QuestionManager * _questionManager)
{
	VfsBase::init(_panel,_questionManager);

	panel->setLabel(_("last used files"),"history");
	setHeaders(settings.getHeaders("History"));
}
